/*
 * Example 3 during tutorials on April 5, 2016.
 * Modified from example given by Prof. Manzara.
 */
public class Client extends Thread{
	// The client's bank account, shared with another client. Data corruptiong or race conditions
	// happen when multiple processes/threads access the same variables.
	BankAccount sharedAccount;
	
	/**
	 * Create a Client and set their bank account.
	 * @param bankAccount
	 */
	public Client(BankAccount bankAccount){
		this.sharedAccount = bankAccount;
	}
	
	/**
	 * All Threads have to have a run() method before it can be started. Here we just withdraw $100 when the
	 * thread starts. If your withdraw method is synchronized, this will work fine. If it is not synchronized,
	 * multiple Clients withdrawing from the same account may lead to data corruption.
	 */
	public void run(){
		sharedAccount.withdraw(100);
	}
}
